new g_ownReasons[MAXPLAYERS+1] = {false, ...};

public OnClientDisconnect(client)
{
	g_ownReasons[client] = false;
}

public Action:SayChat(client, const String:command[], argc)
{
	if (g_ownReasons[client])
	{
		new String:reason[512];
		GetCmdArgString(reason, sizeof(reason));
		StripQuotes(reason);	
		
		g_ownReasons[client] = false;
		
		if(strcmp(reason[0], "!noreason") == 0)
		{
			PrintToChat(client, "\x01\x05[SM] \x01Ввод своей причины отменен");
			return Plugin_Handled;
		}		
		PrepareBan(client, g_BanTarget[client], g_BanTime[client], reason);		
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

PrepareBan(client, target, time, const String:reason[])
{
	new originalTarget = GetClientOfUserId(g_BanTargetUserId[client]);

	if (originalTarget != target)
	{
		if (client == 0)
		{
			PrintToServer("[SM] %t", "Player no longer available");
		}
		else
		{
			PrintToChat(client, "\x05[SM]\x01 %t", "Player no longer available");
		}

		return;
	}

	decl String:authid[64], String:name[32];
	GetClientAuthString(target, authid, sizeof(authid));
	GetClientName(target, name, sizeof(name));

	if (!time)
	{
		if (reason[0] == '\0')
		{
			ShowActivity(client, "%t", "Permabanned player", name);
		} 
		else 
		{
			ShowActivity(client, "%t", "Permabanned player reason", name, reason);
		}
	} 
	else
	{
		if (reason[0] == '\0')
		{
			ShowActivity(client, "%t", "Banned player", name, time);
		} 
		else 
		{
			ShowActivity(client, "%t", "Banned player reason", name, time, reason);
		}
	}

	LogAction(client, target, "\"%L\" banned \"%L\" (minutes \"%d\") (reason \"%s\")", client, target, time, reason);

	if (reason[0] == '\0')
	{
		BanClient(target, time, BANFLAG_AUTO, "Banned", "Banned", "sm_ban", client);
	}
	else
	{
		BanClient(target, time, BANFLAG_AUTO, reason, reason, "sm_ban", client);
	}
}

public AdminMenu_Ban(Handle:topmenu,
							  TopMenuAction:action,
							  TopMenuObject:object_id,
							  param,
							  String:buffer[],
							  maxlength)
{
	g_ownReasons[param] = false;
	
	if (action == TopMenuAction_DisplayOption)
	{
		Format(buffer, maxlength, "%T", "Ban player", param);
	}
	else if (action == TopMenuAction_SelectOption)
	{
		DisplayBanTargetMenu(param);
	}
}

DisplayBanTargetMenu(client)
{
	new Handle:menu = CreateMenu(MenuHandler_BanPlayerList);

	decl String:title[100];
	Format(title, sizeof(title), "%T:", "Ban player", client);
	SetMenuTitle(menu, title);
	SetMenuExitBackButton(menu, true);

	decl String:userid[15], String:name[32]; 
	for (new i = 1; i <= MaxClients; i++) 
	{ 
		if (IsClientInGame(i) && !IsFakeClient(i)) 
		{
			if (GetClientTeam(i) == 1)
			{
				decl String:sp[20];
				IntToString(GetClientUserId(i), userid, sizeof(userid)); 
				GetClientName(i, name, sizeof(name)); 
				Format(sp, sizeof(sp), "[SPEC] %s", name);
				AddMenuItem(menu, userid, sp);
			}
			else if (GetClientTeam(i) == 2)
			{
				decl String:t[20];
				IntToString(GetClientUserId(i), userid, sizeof(userid)); 
				GetClientName(i, name, sizeof(name)); 
				Format(t, sizeof(t), "[T] %s", name);
				AddMenuItem(menu, userid, t);
			}
			else if (GetClientTeam(i) == 3)
			{
				decl String:ct[20];
				IntToString(GetClientUserId(i), userid, sizeof(userid)); 
				GetClientName(i, name, sizeof(name)); 
				Format(ct, sizeof(ct), "[CT] %s", name);
				AddMenuItem(menu, userid, ct);
			}
			else
			{
				decl String:xz[20];
				IntToString(GetClientUserId(i), userid, sizeof(userid)); 
				GetClientName(i, name, sizeof(name)); 
				Format(xz, sizeof(xz), "[ ] %s", name);
				AddMenuItem(menu, userid, xz);
			}
		} 
	}
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

DisplayBanTimeMenu(client)
{
	new Handle:menu = CreateMenu(MenuHandler_BanTimeList);

	decl String:title[100];
	Format(title, sizeof(title), "%T: %N", "Ban player", client, g_BanTarget[client]);
	SetMenuTitle(menu, title);
	SetMenuExitBackButton(menu, true);

	AddMenuItem(menu, "0", "Навсегда");
	AddMenuItem(menu, "5", "5 Минут");
	AddMenuItem(menu, "10", "10 Минут");
	AddMenuItem(menu, "30", "30 Минут");
	AddMenuItem(menu, "60", "1 Час");
	AddMenuItem(menu, "240", "4 Часа");
	AddMenuItem(menu, "1440", "1 День");
	AddMenuItem(menu, "4320", "3 Дня");
	AddMenuItem(menu, "10080", "1 Неделя");
	AddMenuItem(menu, "40320", "1 Месяц");
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

DisplayBanReasonMenu(client)
{
	new Handle:menu = CreateMenu(MenuHandler_BanReasonList);

	decl String:title[100];
	Format(title, sizeof(title), "%T: %N", "Ban reason", client, g_BanTarget[client]);
	SetMenuTitle(menu, title);
	SetMenuExitBackButton(menu, true);
	AddMenuItem(menu, "Чит: Видеть сквозь стены", "Чит: Видеть сквозь стены");
	AddMenuItem(menu, "Чит: Автоприцеливание", "Чит: Автоприцеливание");
	AddMenuItem(menu, "Чит: Скорость", "Чит: Скорость");	
	AddMenuItem(menu, "Расизм", "Расизм");
	AddMenuItem(menu, "Реклама", "Реклама");
	AddMenuItem(menu, "Оскорбление игроков", "Оскорбление игроков");	
	AddMenuItem(menu, "Использование багов", "Использование багов");
	AddMenuItem(menu, "Эксплойт сервера", "Эксплойт сервера");	
	AddMenuItem(menu, "Спам в микрофон", "Спам в микрофон");
	AddMenuItem(menu, "Спам в чат", "Спам в чат");
	AddMenuItem(menu, "Кемпинг", "Кемпинг");
	AddMenuItem(menu, "Неуважение к администратору", "Неуважение к администратору");
	AddMenuItem(menu, "Ослепление товарищей по команде", "Ослепление товарищей по команде");
	AddMenuItem(menu, "Убийство товарища по команде", "Убийство товарища по команде");
	AddMenuItem(menu, "Нарушение правил сервера", "Нарушение правил сервера");	
	AddMenuItem(menu, "Недопустимый спрей", "Недопустимый спрей");
	AddMenuItem(menu, "other", "Своя причина");
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_BanReasonList(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[64];

		GetMenuItem(menu, param2, info, sizeof(info));
				
		if(strcmp("other", info) == 0)
		{
			// admin wants to use his own reason
			g_ownReasons[param1] = true;
			PrintToChat(param1, "\x01\x05[SM] \x01Введите причину в чат. !noreason - Отмена бана");
			return;
		}
		if(g_BanTarget[param1] != -1 && g_BanTime[param1] != -1)
		PrepareBan(param1, g_BanTarget[param1], g_BanTime[param1], info);
	}
}

public MenuHandler_BanPlayerList(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32], String:name[32];
		new userid, target;

		GetMenuItem(menu, param2, info, sizeof(info), _, name, sizeof(name));
		userid = StringToInt(info);

		if ((target = GetClientOfUserId(userid)) == 0)
		{
			PrintToChat(param1, "\x05[SM]\x01 %t", "Player no longer available");
		}
		else if (!CanUserTarget(param1, target))
		{
			PrintToChat(param1, "\x05[SM]\x01 %t", "Unable to target");
		}
		else
		{
			g_BanTarget[param1] = target;
			g_BanTargetUserId[param1] = userid;
			DisplayBanTimeMenu(param1);
		}
	}
}

public MenuHandler_BanTimeList(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
	}
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && hTopMenu != INVALID_HANDLE)
		{
			DisplayTopMenu(hTopMenu, param1, TopMenuPosition_LastCategory);
		}
	}
	else if (action == MenuAction_Select)
	{
		decl String:info[32];

		GetMenuItem(menu, param2, info, sizeof(info));
		g_BanTime[param1] = StringToInt(info);

		DisplayBanReasonMenu(param1);
	}
}


public Action:Command_Ban(client, args)
{
	if (args < 2)
	{
		ReplyToCommand(client, "\x05[SM]\x01 Используйте: sm_ban <#userid|name> <minutes|0> [reason]");
		return Plugin_Handled;
	}

	decl len, next_len;
	decl String:Arguments[256];
	GetCmdArgString(Arguments, sizeof(Arguments));

	decl String:arg[65];
	len = BreakString(Arguments, arg, sizeof(arg));

	new target = FindTarget(client, arg, true);
	if (target == -1)
	{
		return Plugin_Handled;
	}

	decl String:s_time[12];
	if ((next_len = BreakString(Arguments[len], s_time, sizeof(s_time))) != -1)
	{
		len += next_len;
	}
	else
	{
		len = 0;
		Arguments[0] = '\0';
	}

	new time = StringToInt(s_time);

	g_BanTargetUserId[client] = GetClientUserId(target);

	PrepareBan(client, target, time, Arguments[len]);

	return Plugin_Handled;
}